//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3B7AC0AC00EF.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3B7AC0AC00EF.cm

//## begin module%3B7AC0AC00EF.cp preserve=no
//## end module%3B7AC0AC00EF.cp

//## Module: StatMethod%3B7AC0AC00EF; Package specification
//## Subsystem: XSFit::Fit%3677C9158350
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/Fit/StatMethod.h

#ifndef STATMETHOD_H
#define STATMETHOD_H 1

//## begin module%3B7AC0AC00EF.additionalIncludes preserve=no
//## end module%3B7AC0AC00EF.additionalIncludes

//## begin module%3B7AC0AC00EF.includes preserve=yes
//## end module%3B7AC0AC00EF.includes

// xsTypes
#include <main/xsTypes.h>
// string
#include <string>
// map
#include <map>
// Error
#include <XSUtil/Error/Error.h>
// FitStrategy
#include <XSFit/Fit/FitStrategy.h>
// Bayes
#include <XSFit/Fit/Bayes.h>

//## Modelname: XSModel::GlobalContainer%3E42929A0210
namespace XSContainer {
    class Weight;

} // namespace XSContainer

//## begin module%3B7AC0AC00EF.declarations preserve=no
//## end module%3B7AC0AC00EF.declarations

//## begin module%3B7AC0AC00EF.additionalDeclarations preserve=yes
//#include "Global/XSGlobal.h"
class Model;
class ModParam;
class SpectralData;
//## end module%3B7AC0AC00EF.additionalDeclarations


//## begin StatMethod%3A7EC4660115.preface preserve=yes
//## end StatMethod%3A7EC4660115.preface

//## Class: StatMethod%3A7EC4660115; protected
//## Category: XSFit::Fit%36349D710188
//## Subsystem: XSFit::Fit%3677C9158350
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3B7BE85703C0;std::map { -> }
//## Uses: <unnamed>%3C5997D20025;ArrayContainer { -> }
//## Uses: <unnamed>%4224A5B80368;Bayes { -> }

class StatMethod : public FitStrategy  //## Inherits: <unnamed>%3A7EC47E028F
{
  //## begin StatMethod%3A7EC4660115.initialDeclarations preserve=yes
  //## end StatMethod%3A7EC4660115.initialDeclarations

  public:
    //## Class: InvalidSpectrumNumber%3C5995000060
    //	Invalid spectrum number thrown by lookup error for
    //	the Spectrum's workspace arrays. This will be fatal.
    //## Category: XSFit::Fit%36349D710188
    //## Subsystem: XSFit::Fit%3677C9158350
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class InvalidSpectrumNumber : public RedAlert  //## Inherits: <unnamed>%3C59959C01D7
    {
      public:
        //## Constructors (specified)
          //## Operation: InvalidSpectrumNumber%3C59951000AA
          InvalidSpectrumNumber (size_t num);

      protected:
      private:
      private: //## implementation
    };

    //## Class: InvalidParameterError%3C5AA9D50392
    //## Category: XSFit::Fit%36349D710188
    //## Subsystem: XSFit::Fit%3677C9158350
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class InvalidParameterError : public RedAlert  //## Inherits: <unnamed>%3C5AAA3000C1
    {
      public:
        //## Constructors (specified)
          //## Operation: InvalidParameterError%3C5AA9F301F7
          InvalidParameterError ();

      protected:
      private:
      private: //## implementation
    };

    //## Class: FitNotDefined%3CF4DF930151
    //## Category: XSFit::Fit%36349D710188
    //## Subsystem: XSFit::Fit%3677C9158350
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class FitNotDefined : public YellowAlert  //## Inherits: <unnamed>%3CF4E0A60153
    {
      public:
        //## Constructors (specified)
          //## Operation: FitNotDefined%3CF4DFA801F5
          FitNotDefined (const string& diag);

      protected:
      private:
      private: //## implementation
    };

    //## Class: NoSuchSpectrum%3CF4E6D90146
    //## Category: XSFit::Fit%36349D710188
    //## Subsystem: XSFit::Fit%3677C9158350
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class NoSuchSpectrum : public YellowAlert  //## Inherits: <unnamed>%3CF4E7000102
    {
      public:
        //## Constructors (specified)
          //## Operation: NoSuchSpectrum%3CF4E70B017D
          NoSuchSpectrum (const string& diag);

      protected:
      private:
      private: //## implementation
    };

    //## Destructor (generated)
      virtual ~StatMethod();


    //## Other Operations (specified)
      //## Operation: differentiate%3B7A98E60078
      void differentiate (Fit* fit, const IntegerArray& which);

      //## Operation: get%3B7AC9C00310
      static StatMethod* get (const std::string& name);

      //## Operation: registerMethod%3BFABE250331
      static void registerMethod (const string& name, StatMethod* method);

      //## Operation: registerWeightingMethod%3C3F65630169
      //	Weightings are sometimes called by SpectralData
      //	at instantiation time for spectra, and sometimes by
      //	statMethod when they involve the model as
      //	well as the data (and therefore affect derivatives with
      //	respect to parameters).
      static void registerWeightingMethod (const std::string& name, XSContainer::Weight* weightMethod);

      //## Operation: weightScheme%3C443FE103A3
      static XSContainer::Weight* weightScheme (const std::string& name);

      //## Operation: setWeight%3C4EF50803C8
      //	Public virtual to set weighting  scheme. The base class
      //	implementation sets the weight scheme to "standard"
      //	and issues a warning that the statistical method doesn't
      //	recognize other weight schemes than standard (i.e.,
      //	use the variance). This will be overriden by statistics
      //	that
      //	behave like chi^2 and do admit other weightings.
      virtual void setWeight (const std::string& weightName);

      //## Operation: initialize%3C598D9D0155
      void initialize (Fit* fit);

      //## Operation: deallocate%3C5AACD200A3
      void deallocate ();

      //## Operation: renormalize%3C5FF135039D
      void renormalize (Fit* fit);

      //## Operation: weightNames%3C83B9C500DE
      static string weightNames ();

      //## Operation: statNames%3C83B9D90119
      static string statNames ();

      //## Operation: clone%3C84EC5F0214
      virtual StatMethod* clone () const = 0;

      //## Operation: degreesOfFreedom%3C87D3D70102
      void degreesOfFreedom (Fit* fit, int& degrees, size_t& bins) const;

      //## Operation: report%3C90CE980078
      void report (Fit* fit) const;

      //## Operation: resetDerivativeArrays%3CA33F6403DD
      void resetDerivativeArrays ();

      //## Operation: peakResidual%3CF3F23C0244
      void peakResidual (const Fit* fit, std::pair<Real,Real>& max, std::pair<Real,Real>& min, size_t spectrum, const std::pair<Real,Real> range) const;

      //## Operation: plotChi%3DD26EB200FE
      virtual Real plotChi (Real obs, Real mod, Real error, Real areaTime, const Real& NODATA) const;

      //## Operation: plotDeltaChi%3DD26EBA0278
      virtual Real plotDeltaChi (Real obs, Real mod, Real error, const Real& NODATA) const;

      //## Operation: fullName%3DD3F15200F0
      virtual const string& fullName () const = 0;

      //## Operation: scriptName%3DD4058C0076
      //	return string used to denote stat method while plotting.
      //
      //	abstract.
      virtual const string& scriptName () const = 0;

      //## Operation: isBayesOn%4224AA4C0344
      static bool isBayesOn ();

      //## Operation: setBayesOn%4224AAA301B5
      static void setBayesOn (bool flag);

      //## Operation: clearMethods%429F4C690378
      static void clearMethods ();

      //## Operation: clearWeightingMethods%429F4D9C01F9
      static void clearWeightingMethods ();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: statistic%3B7A994D00FD
      Real statistic () const;
      void statistic (Real value);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSFit::Fit::Second Derivative%3B7A97DC03B3
      //## Role: StatMethod::alpha%3B7A97DD03D5
      //## Qualifier: npar%3C7E7B0001B0; size_t
      const RealArray& alpha () const;
      void setAlpha (const RealArray& value);
      Real alpha (size_t npar) const;
      void alpha (size_t npar, Real value);

      //## Association: XSFit::Fit::<unnamed>%3B7AC8A003C5
      //## Role: StatMethod::statMethods%3B7AC8A400EE
      //## Qualifier: name%3B7AC8D20096; std::string
      static const std::map<std::string, StatMethod*> statMethods ();
      static void statMethods (std::map<std::string, StatMethod*> value);

      //## Association: XSFit::Fit::<unnamed>%3B7BF079022B
      //## Role: StatMethod::name%3B7BF07A01B7
      const std::string& name () const;
      void name (const std::string& value);

      //## Association: XSFit::Fit::<unnamed>%3C435432013A
      //## Role: StatMethod::weightScheme%3C435433013F
      //## Qualifier: name%3C435462003A; string
      static const std::map<string, XSContainer::Weight*>& weightScheme ();

      //## Association: XSFit::Fit::First Derivative%3C59A93901E1
      //## Role: StatMethod::beta%3C59A93901E3
      //## Qualifier: npar%3C7E7AD70207; size_t
      const RealArray& beta () const;
      void setBeta (const RealArray& value);
      Real beta (size_t npar) const;
      void beta (size_t npar, Real value);

  public:
    // Additional Public Declarations
      //## begin StatMethod%3A7EC4660115.public preserve=yes
      //## end StatMethod%3A7EC4660115.public

  protected:
    //## Constructors (generated)
      StatMethod(const StatMethod &right);

    //## Constructors (specified)
      //## Operation: StatMethod%3A7EC4BE02E8
      StatMethod (const std::string& name);


    //## Other Operations (specified)
      //## Operation: doInitialize%3C598DC800CE
      virtual void doInitialize (Fit* fit);

      //## Operation: doDeallocate%3C5AAD060261
      virtual void doDeallocate ();

      //## Operation: getWeightDerivs%3D04DBD50293
      virtual void getWeightDerivs (Fit* fit);

      //## Operation: setOutputFormat%4343FA650032
      virtual Real setOutputFormat (Fit* fit, int degrees = 0) const;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: bayes%4224A50401DC
      static Bayes& bayes ();

      //## Attribute: isDerivAnalytic%45B0D9B0036D
      //	StatMethods which set this flag to true need to make
      //	sure sumDerivs and sumSecondDerivs functions are
      //	properly overriden.  These will be called by analytic
      //	Differentiate function.
      bool isDerivAnalytic () const;
      void isDerivAnalytic (bool value);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSFit::Fit::<unnamed>%3C4354EA03CD
      //## Role: StatMethod::weight%3C4354EB0331
      XSContainer::Weight* weight () const;
      void weight (XSContainer::Weight* value);

      //## Association: XSFit::Fit::Model Derivative%3C59AEF700EA
      //## Role: StatMethod::dModel%3C59AEF700EB
      //## Qualifier: paramNum%3C7E86A60295; size_t
      std::map<size_t,ArrayContainer>& dModel ();

      //## Association: XSFit::Fit::<unnamed>%3CA1F5440374
      //## Role: StatMethod::protoWorkspace%3CA1F54502DE
      const ArrayContainer& protoWorkspace () const;

      //## Association: XSFit::Fit::FoldedMod Derivative%4166B4BB005F
      //## Role: StatMethod::dRM%4166B4BC0396
      std::map<size_t,ArrayContainer>& dRM ();

    // Additional Protected Declarations
      //## begin StatMethod%3A7EC4660115.protected preserve=yes
      //## end StatMethod%3A7EC4660115.protected

  private:

    //## Other Operations (specified)
      //## Operation: doReport%3C90CEE602D5
      virtual void doReport (Fit* fit) const = 0;

      //## Operation: doReset%3C6BE41C001A
      virtual void doReset (Fit* fit) = 0;

      //## Operation: doPeakResidual%3CF3F2BF02BB
      void doPeakResidual (const Fit* fit, const ArrayContainer& difference, std::pair<Real,Real>& max, std::pair<Real,Real>& min, size_t spectrum, const std::pair<Real,Real> range) const;

      //## Operation: sumDerivs%3D04DB7D0044
      virtual Real sumDerivs (int parameterIndex, bool isRespar = false);

      //## Operation: getDifferences%3FAFB73D0395
      virtual ArrayContainer getDifferences (const Fit* fit) const = 0;

      //## Operation: sumSecondDerivs%4166FC680073
      virtual Real sumSecondDerivs (int pi, int pj, bool isPiResp = false, bool isPjResp = false);

      //## Operation: adjustForFrozen%448454E30068
      virtual std::pair<Real,Real> adjustForFrozen (const SpectralData* spec, const std::vector<Model*>& models, const std::map<Model*,ArrayContainer >& savedValsForFrozen) = 0;

      //## Operation: numericalDifferentiate%45B0DAF5013E
      void numericalDifferentiate (Fit* fit, const IntegerArray& parNums);

      //## Operation: analyticDifferentiate%45B0DB84028A
      void analyticDifferentiate (Fit* fit, const IntegerArray& parNums);

    // Additional Private Declarations
      //## begin StatMethod%3A7EC4660115.private preserve=yes
      //## end StatMethod%3A7EC4660115.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin StatMethod::statistic%3B7A994D00FD.attr preserve=no  public: Real {U} 
      Real m_statistic;
      //## end StatMethod::statistic%3B7A994D00FD.attr

      //## begin StatMethod::bayes%4224A50401DC.attr preserve=no  protected: static Bayes {U} Bayes()
      static Bayes s_bayes;
      //## end StatMethod::bayes%4224A50401DC.attr

      //## begin StatMethod::isDerivAnalytic%45B0D9B0036D.attr preserve=no  protected: bool {U} 
      bool m_isDerivAnalytic;
      //## end StatMethod::isDerivAnalytic%45B0D9B0036D.attr

    // Data Members for Associations

      //## Association: XSFit::Fit::Second Derivative%3B7A97DC03B3
      //## begin StatMethod::alpha%3B7A97DD03D5.role preserve=no  public: RealArray { -> 1VHgN}
      RealArray m_alpha;
      //## end StatMethod::alpha%3B7A97DD03D5.role

      //## Association: XSFit::Fit::<unnamed>%3B7AC8A003C5
      //## begin StatMethod::statMethods%3B7AC8A400EE.role preserve=no  public: static StatMethod { -> 1..nRHgN}
      static std::map<std::string, StatMethod*> s_statMethods;
      //## end StatMethod::statMethods%3B7AC8A400EE.role

      //## Association: XSFit::Fit::<unnamed>%3B7BF079022B
      //## begin StatMethod::name%3B7BF07A01B7.role preserve=no  public: std::string { -> 1VHgN}
      std::string m_name;
      //## end StatMethod::name%3B7BF07A01B7.role

      //## Association: XSFit::Fit::<unnamed>%3C435432013A
      //## begin StatMethod::weightScheme%3C435433013F.role preserve=no  public: static XSContainer::Weight { -> 1..nRFHgN}
      static std::map<string, XSContainer::Weight*> s_weightScheme;
      //## end StatMethod::weightScheme%3C435433013F.role

      //## Association: XSFit::Fit::<unnamed>%3C4354EA03CD
      //## begin StatMethod::weight%3C4354EB0331.role preserve=no  protected: XSContainer::Weight { -> 1RFHgN}
      XSContainer::Weight* m_weight;
      //## end StatMethod::weight%3C4354EB0331.role

      //## Association: XSFit::Fit::First Derivative%3C59A93901E1
      //## begin StatMethod::beta%3C59A93901E3.role preserve=no  public: RealArray { -> 1VHgN}
      RealArray m_beta;
      //## end StatMethod::beta%3C59A93901E3.role

      //## Association: XSFit::Fit::Model Derivative%3C59AEF700EA
      //## begin StatMethod::dModel%3C59AEF700EB.role preserve=no  protected: ArrayContainer { -> 1..nVHgN}
      std::map<size_t,ArrayContainer> m_dModel;
      //## end StatMethod::dModel%3C59AEF700EB.role

      //## Association: XSFit::Fit::<unnamed>%3CA1F5440374
      //## begin StatMethod::protoWorkspace%3CA1F54502DE.role preserve=no  protected: ArrayContainer { -> 1VHgN}
      ArrayContainer m_protoWorkspace;
      //## end StatMethod::protoWorkspace%3CA1F54502DE.role

      //## Association: XSFit::Fit::FoldedMod Derivative%4166B4BB005F
      //## begin StatMethod::dRM%4166B4BC0396.role preserve=no  protected: ArrayContainer { -> 1..nVHgN}
      std::map<size_t,ArrayContainer> m_dRM;
      //## end StatMethod::dRM%4166B4BC0396.role

    // Additional Implementation Declarations
      //## begin StatMethod%3A7EC4660115.implementation preserve=yes
      //## end StatMethod%3A7EC4660115.implementation

};

//## begin StatMethod%3A7EC4660115.postscript preserve=yes
//## end StatMethod%3A7EC4660115.postscript

// Class StatMethod::InvalidSpectrumNumber 

// Class StatMethod::InvalidParameterError 

// Class StatMethod::FitNotDefined 

// Class StatMethod::NoSuchSpectrum 

// Class StatMethod 


//## Other Operations (inline)
inline bool StatMethod::isBayesOn ()
{
  //## begin StatMethod::isBayesOn%4224AA4C0344.body preserve=yes
   return s_bayes.isOn();
  //## end StatMethod::isBayesOn%4224AA4C0344.body
}

inline void StatMethod::setBayesOn (bool flag)
{
  //## begin StatMethod::setBayesOn%4224AAA301B5.body preserve=yes
   s_bayes.isOn(flag);
  //## end StatMethod::setBayesOn%4224AAA301B5.body
}

//## Get and Set Operations for Class Attributes (inline)

inline Real StatMethod::statistic () const
{
  //## begin StatMethod::statistic%3B7A994D00FD.get preserve=no
  return m_statistic;
  //## end StatMethod::statistic%3B7A994D00FD.get
}

inline void StatMethod::statistic (Real value)
{
  //## begin StatMethod::statistic%3B7A994D00FD.set preserve=no
  m_statistic = value;
  //## end StatMethod::statistic%3B7A994D00FD.set
}

inline Bayes& StatMethod::bayes ()
{
  //## begin StatMethod::bayes%4224A50401DC.get preserve=no
  return s_bayes;
  //## end StatMethod::bayes%4224A50401DC.get
}

inline bool StatMethod::isDerivAnalytic () const
{
  //## begin StatMethod::isDerivAnalytic%45B0D9B0036D.get preserve=no
  return m_isDerivAnalytic;
  //## end StatMethod::isDerivAnalytic%45B0D9B0036D.get
}

inline void StatMethod::isDerivAnalytic (bool value)
{
  //## begin StatMethod::isDerivAnalytic%45B0D9B0036D.set preserve=no
  m_isDerivAnalytic = value;
  //## end StatMethod::isDerivAnalytic%45B0D9B0036D.set
}

//## Get and Set Operations for Associations (inline)

inline const RealArray& StatMethod::alpha () const
{
  //## begin StatMethod::alpha%3B7A97DD03D5.get preserve=no
  return m_alpha;
  //## end StatMethod::alpha%3B7A97DD03D5.get
}

inline void StatMethod::setAlpha (const RealArray& value)
{
  //## begin StatMethod::setAlpha%3B7A97DD03D5.set preserve=yes
  m_alpha.resize(value.size());
  m_alpha = value;
  //## end StatMethod::setAlpha%3B7A97DD03D5.set
}

inline Real StatMethod::alpha (size_t npar) const
{
  //## begin StatMethod::alpha%3B7A97DD03D5.qualget preserve=no
  return m_alpha[npar];
  //## end StatMethod::alpha%3B7A97DD03D5.qualget
}

inline void StatMethod::alpha (size_t npar, Real value)
{
  //## begin StatMethod::alpha%3B7A97DD03D5.qualset preserve=no
  m_alpha[npar] = value;
  //## end StatMethod::alpha%3B7A97DD03D5.qualset
}

inline const std::map<std::string, StatMethod*> StatMethod::statMethods ()
{
  //## begin StatMethod::statMethods%3B7AC8A400EE.get preserve=no
  return s_statMethods;
  //## end StatMethod::statMethods%3B7AC8A400EE.get
}

inline void StatMethod::statMethods (std::map<std::string, StatMethod*> value)
{
  //## begin StatMethod::statMethods%3B7AC8A400EE.set preserve=no
  s_statMethods = value;
  //## end StatMethod::statMethods%3B7AC8A400EE.set
}

inline const std::string& StatMethod::name () const
{
  //## begin StatMethod::name%3B7BF07A01B7.get preserve=no
  return m_name;
  //## end StatMethod::name%3B7BF07A01B7.get
}

inline void StatMethod::name (const std::string& value)
{
  //## begin StatMethod::name%3B7BF07A01B7.set preserve=no
  m_name = value;
  //## end StatMethod::name%3B7BF07A01B7.set
}

inline const std::map<string, XSContainer::Weight*>& StatMethod::weightScheme ()
{
  //## begin StatMethod::weightScheme%3C435433013F.get preserve=no
  return s_weightScheme;
  //## end StatMethod::weightScheme%3C435433013F.get
}

inline XSContainer::Weight* StatMethod::weight () const
{
  //## begin StatMethod::weight%3C4354EB0331.get preserve=no
  return m_weight;
  //## end StatMethod::weight%3C4354EB0331.get
}

inline const RealArray& StatMethod::beta () const
{
  //## begin StatMethod::beta%3C59A93901E3.get preserve=no
  return m_beta;
  //## end StatMethod::beta%3C59A93901E3.get
}

inline void StatMethod::setBeta (const RealArray& value)
{
  //## begin StatMethod::setBeta%3C59A93901E3.set preserve=yes
  m_beta.resize(value.size());
  m_beta = value;
  //## end StatMethod::setBeta%3C59A93901E3.set
}

inline Real StatMethod::beta (size_t npar) const
{
  //## begin StatMethod::beta%3C59A93901E3.qualget preserve=no
  return m_beta[npar];
  //## end StatMethod::beta%3C59A93901E3.qualget
}

inline void StatMethod::beta (size_t npar, Real value)
{
  //## begin StatMethod::beta%3C59A93901E3.qualset preserve=no
  m_beta[npar] = value;
  //## end StatMethod::beta%3C59A93901E3.qualset
}

inline std::map<size_t,ArrayContainer>& StatMethod::dModel ()
{
  //## begin StatMethod::dModel%3C59AEF700EB.get preserve=no
  return m_dModel;
  //## end StatMethod::dModel%3C59AEF700EB.get
}

inline const ArrayContainer& StatMethod::protoWorkspace () const
{
  //## begin StatMethod::protoWorkspace%3CA1F54502DE.get preserve=no
  return m_protoWorkspace;
  //## end StatMethod::protoWorkspace%3CA1F54502DE.get
}

inline std::map<size_t,ArrayContainer>& StatMethod::dRM ()
{
  //## begin StatMethod::dRM%4166B4BC0396.get preserve=no
  return m_dRM;
  //## end StatMethod::dRM%4166B4BC0396.get
}

//## begin module%3B7AC0AC00EF.epilog preserve=yes
//## end module%3B7AC0AC00EF.epilog


#endif
